/*Ikurso MMT1 1pogrupis Neringa Palepsyte s2 .Parasyti paprogramiu rinkini darbui su dvipusiu sarasu:
Sukuria nauja elementa  
Iterpti elementa i saraso pradzia 
Iterpti elementa i saraso pabaiga 
Iterpti elementa pries k-taji elementa
Iterpti elementa po k-ojo elemento
Atspausdinti elementu sarasa
Istrinti elementu sarasa
Pakeisti elemento reiksme
Panaikinti k-taji saraso elementa
Ieskoti elemento      
Gauti elemento reiksme     
Suskaiciuoti saraso elementus   */


#include <stdio.h>
#include <stdlib.h>

typedef struct LinkedList   // typedef leidzia atvira koda
{
    int value;
    struct LinkedList *next, *prev;      //vienos krypties sarasas ir jo rodykles  i kita ir i pries tai esanti 
}  List;  //tipo pavadinimas

//-------------------------Sukuria nauja elementa-------------------------------

List *NewElement() { //grazina ne elemento reiksme, o rodykle, nes *
    List *element; //saugosiu rodykle i sarasa (buto nr)
    if (NULL == (element = malloc(sizeof(List)))) {// sukuriamas saraso elementas,malloc ishskiria tiek atminties kiek nurodo sizeof
        printf("Atminties iskirti nepavyko programa baigia darba");//jei truksta atminties ar pan. t.y. nesukuriamas, malloc rodo i null
        exit(0);// jei nepavyko ishskirti atminties iseina is programos
    }
    element->next = NULL;//apibreziam, kad siuksles nesuklaidintu darbo
    element->prev = NULL;
    return element;//rodykles grazinimas
}

//------------------------Iterpti elementa i saraso pradzia---------------------

void InsertIntoBegining(List **firstElement) {//  paskalio var imitacija **
    List *element = NewElement();                                                       
    int number;// elemento duomuo
    
    printf("Iveskite norima iterpti reiksme: ");
    scanf("%d", &number);
    
    element->value = number;//elemento duomeni priskiria rodykles reiksmei (value - rodykles elementas)
    
    if ((*firstElement) != NULL) {
        element->next = *firstElement;
        (*firstElement)->prev = element;
    }
    
    printf("Elementas sekmingai iterptas.\n");
    *firstElement = element;  
} 

//-----------------------Iterpti elementa i saraso pabaiga----------------------

void InsertIntoEnd(List **lastElement) {
    List *element = NewElement();                                                       
    int number; // elemento duomuo
    
    printf("Iveskite norima iterpti reiksme: ");
    scanf("%d", &number);
    
    element->value = number;//elemento duomeni priskiria rodykles reiksmei (value - rodykles elementas)
    
    if ((*lastElement) != NULL) {
        element->prev = *lastElement;
        (*lastElement)->next = element;
    }
    *lastElement = element;
    printf("Elementas sekmingai iterptas.\n"); 
}

//--------------------Iterpti elementa pries k-taji elementa--------------------
                                                                                     
void InsertBelow(List **firstElement) {//  paskalio var imitacija **
    List *element, *movElement;                                                        /* Pagalbines rodykles */
    int place, number, i, pt = 0;
    
    movElement = *firstElement;
    
    printf("Iveskite numeri elemento, pries kuri norite iterpti: ");
    scanf("%d", &place);
    printf("Iveskite norima iterpti reiksme: ");
    scanf("%d", &number);
    
    i = 0;
    while ((movElement != NULL) && (pt == 0)) {
        i++;
        if (place == i) {
            element = NewElement();
            element->value = number;   // jei reiksme sutapo su ieskomo elemento reiksme
            
            if (movElement->prev == NULL) {
                movElement->prev = element;
                element->next = movElement;
                *firstElement = element;
            } else {
                element->next = movElement;
                element->prev = movElement->prev;
                movElement->prev->next = element;
                movElement->prev = element;
            }
            pt = 1;
        }
        movElement = movElement->next;        // pakeicia pasirinkto elemento reiksme
    }
    if (pt == 1) {
        printf("Elementas sekmingai iterptas. \n");
    } else {
        printf("Elemento iterpti nepavyko. \n");
    } 
}
//--------------------Iterpti elementa po k-tojo elemento--------------------

void InsertUnder(List **firstElement, List **lastElement) {         
    List *element, *movElement;                                                        /* Pagalbines rodykles */
    int place, number, i, pt = 0;
    
    movElement = *firstElement;
    
    printf("Iveskite numeri elemento, po kurio norite iterpti: ");
    scanf("%d", &place);
    printf("Iveskite norima iterpti reiksme: ");
    scanf("%d", &number);
    
    i = 0;
    while ((movElement != NULL) && (pt == 0)) {
        i++;
        if (place == i) {
            element = NewElement();
            element->value = number;
            
            if (movElement->next == NULL) {
                movElement->next = element;
                element->prev = movElement;
                *lastElement = element;
            } else {
                element->prev = movElement;
                element->next = movElement->next;
                movElement->next->prev = element;
                movElement->next = element;
            }
            pt = 1;
        }
        movElement = movElement->next;        // pakeicia pasirinkto elemento reiksme
    }
    if (pt == 1) {
        printf("Elementas sekmingai iterptas. \n");
    } else {
        printf("Elemento iterpti nepavyko. \n");
    } 
}
//-------------------Atspausdinti elementu sarasa-------------------------------

void PrintList(List *firstElement) {//grazina ne elemento reiksme, o rodykle, nes *
    List *element;
    element = firstElement;
    printf("Saraso elementai:\n");
    while (element != NULL) {
        printf("%i\n", element->value); //atspausdina elemento reiksme, integer pavidalu
        element = element->next; //pereine prie sekancio
    }
}

//-------------------Istrinti elementu sarasa-----------------------------------

void DeleteList(List **firstElement, List **lastElement) {
    List *element;                                                                  
    while ((*firstElement) != NULL) { 
        element = (*firstElement)->next;
        free(*firstElement);
        (*firstElement) = element;
    }    
    *firstElement = NULL;
    *lastElement = NULL;
    printf("Sarasas sekmingai pasalintas.\n");
}

//---------------------Pakeisti elemento reiksme--------------------------------

void SetValue(List **firstElement) {                                  
    List *element;
    int place, pt = 0, n = 0, value = 0, number;
    element = *firstElement;
    printf("Iveskite elmento numeri, kurio reiksme norite pakeisti: ");
    scanf("%d", &place);    
    printf("Iveskite nauja elemento reiksme: ");
    scanf("%d", &value);

    while ((element != NULL) && (pt == 0)) { 
        n++;
        if (n == place) {
            element->value = value;
            pt = 1;                  //patikrinimo elementas 1- rastas 0 - nerastas 
        }
        element = element->next;     // pakeicia pasirinkto elemento reiksme
    }
    
    if (pt == 1) {
        printf("Elemento numeriu %i, reiksme sekmingai pakeista i %i.\n",place, value);
    } else printf("Elemento reiksmes pakeisti nepavyko");
}


//-------------------Istrinti k-taji elementa-----------------------------------

void DeleteCurrent(List **firstElement, List **lastElement) {
    List *element, *movElement;                                                  /* Pagaalbines rodykles */
    int place, i, pt = 0;   
    movElement = *firstElement;
    
    printf("Iveskite numeri elemento, kuri norite pasalinti: ");
    scanf("%d", &place);
    
    i = 0;
    while ((movElement != NULL) && (pt == 0)) { 
        i++;
        List *element;
        if (i == place) {
            if ((movElement->prev == NULL) && (movElement->next == NULL)) { // jei vienas elementas sarase
                free(movElement);
                *firstElement = NULL;
                *lastElement = NULL;
                pt = 1;
            } else if (movElement->prev == NULL) {           // jei saraso elementas pirmas                       
                element = movElement->next;
                element->prev = NULL;
                free(movElement);
                movElement = element;
                *firstElement = element;
            } else if (movElement->next == NULL) {  // jei paskutinis saraso elementas
                element = movElement->prev;
                element->next = NULL;
                free(movElement);
                movElement = element;
                *lastElement = element;
            } else {                                // kai per viduriuka tarp  kitu dvieju elementu
                element = movElement->next;
                element->prev = element->prev->prev;
                element->prev->next = element;
                free(movElement);
                movElement = element;
            }
            pt = 1;
        }
        movElement = movElement->next;
    }    
    if (pt == 1) {
        printf("Elementas sekmingai pasalintas. \n");
    } else {
        printf("Elemento pasalinti nepavyko. \n");
    }
}

//----------------------------Ieskoti elemento----------------------------------

void SearchForElement(List *firstElement) {
    List *element;
    int number, pt = 0, n = 0;
    element = firstElement;
    printf("Iveskite ieskomo elemento reiksme: ");
    scanf("%d", &number);    

    while ((element != NULL) && (pt == 0)) {      //patikrinimo elementas pradzioj 0 - nerasta                            
        n++;
        if (element->value == number) { // jei reiksme sutapo su ieskomo elemento reiksme
            pt = 1;
        }
        element = element->next;
    }
    
    if (pt == 1) {
        printf("Elementas su reiksme %i, sarase yra %i.\n",number, n);
    } else printf("Elemento su reiksme %i sarase nera.\n", number);
}

//------------------------Gauti elemento reiksme--------------------------------

void GetValue(List *firstElement) {
    List *element;
    int place, pt = 0, n = 0, value = 0;
    element = firstElement;
    printf("Iveskite elmento numeri, kurio reiksme norite suzinoti: ");
    scanf("%d", &place); // & duoda to elemento rodykle, nes scan jin reikalinga   

    while ((element != NULL) && (pt == 0)) {                                              
        n++;                 // n po kiekvieno ciklo didinamas vienetu 
        if (n == place) {     // tikrinam ar saraso elementas lygus norimam rasti  
            value = element->value;// verte yra tos rodykles elementas
            pt = 1;                      //patikrinimo elementas 1- rastas 0 - nerastas 
        }                                // value - saraso elemento reiksme 
        element = element->next;
    }
    
    if (pt == 1) {
        printf("Elemento numeriu %i, reiksme yra %i.\n",place, value);
    } else printf("Sarase nera elemento numeriu %i.\n", place);
}

//-----------------------Suskaiciuoti elementu kieki----------------------------

void Count(List *firstElement) {
    List *element;                                                                    
    element = firstElement;
    int n = 0;
    while (element != NULL) { 
        n++;
        element = element->next;
    }  
    printf("Elementu sarase yra: %i\n", n); //%i - integer
}

//----------------------------main funkcija-------------------------------------

int main() {
    List *firstElement = NULL, *lastElement = NULL; // aprasomos darbines rodykles, kurios nukreipiamos i null
    int number = 1;
    while (number != 0) {
          
        printf("\n********************************************\n");
        printf("Pasirinkite veiksma:\n");
        printf("1: Iterpti skaiciu i saraso pradzia.\n");
        printf("2: Iterpti skaiciu i saraso pabaiga\n");
        printf("3: Iterpti pries k-taji elementa\n");
        printf("4: Iterpti elementa po k-ojo elemento\n");
        printf("5: Atspausdinti sarasa\n");
        printf("6: Atspausdinti elementu kieki sarase\n");
        printf("7: Ieskoti elemento.\n");
        printf("8: Suzinoti k-tojo elemento reiksme\n");
        printf("9: Pakeisti elemento reiksme\n");     
        printf("10: Pasalinti k-taji lementa\n");
        printf("11: Istrinti sarasa\n");
        printf("0: baigti darba\n");
        printf("********************************************\n");
        scanf("%d", &number);
        switch (number) {
            case 1: 
                InsertIntoBegining(&firstElement);
                if (lastElement == NULL) {             //isimtis
                    lastElement = firstElement;
                }
                break; //break keyword is used to signal the end of the block, nes kitaip ijungines ir kitus, jei ne tusti 
            case 2:
                InsertIntoEnd(&lastElement);
                if (firstElement == NULL) {         //isimtis
                    firstElement = lastElement;
                }                
                break;
            case 3:
                InsertBelow(&firstElement);
                 break;
            case 4:
                InsertUnder(&firstElement, &lastElement);
                 break;                
            case 5:
                PrintList(firstElement);
                break;
            case 6:
                Count(firstElement);
                break;
            case 7:
                SearchForElement(firstElement);
                break;
            case 8:
                GetValue(firstElement);
                break;
            case 9:
                SetValue(&firstElement);   
                 break;
            case 10:
                DeleteCurrent(&firstElement,&lastElement);
                 break;  
            case 11:
                DeleteList(&firstElement, &lastElement);
                 break;                  
            case 0:
                DeleteList(&firstElement, &lastElement);
        }
    }
    return 0;
}
